#include <stdio.h>
#include <utility>
#include <stdlib.h>
#include <vector>
#include <algorithm>

using std::swap;
using std::min;
using std::vector;

int r[50][50];

bool solve(char *in, char *out) {
//    freopen(in, "r", stdin);
//    freopen(out, "w", stdout);

    int n, m;
    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            scanf("%d", &r[i][j]);

    int k;
    scanf("%d", &k);
    int ks[k];
    for (int i = 0; i < k; i++)
        scanf("%d", &ks[i]);

    int cx, cy = -1;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (r[i][j] == ks[0]) {
                if (cy != -1)
                    return false;

                cx = j;
                cy = i;
            }

    int dx[4] = {-1, 0, 1, 0};
    int dy[4] = {0, -1, 0, 1};

    int height = n;
    int width = m;

    for (int i = 1; i < k; i++) {
        int nx, ny = -1;
        for (int j = 0; j < 4; j++)
            if (cy + dy[j] >= 0 && cy + dy[j] < height &&
                    cx + dx[j] >= 0 && cx + dx[j] < width) {

                if (r[cy + dy[j]][cx + dx[j]] == ks[i]) {

                    if (ny != -1)
                        return false;

                    ny = cy + dy[j];
                    nx = cx + dx[j];
                }
            }

        cy = ny;
        cx = nx;
    }

    if (cx < m / 3)
        printf("Mission accomplished\n");
    else
        printf("Mission failed\n");
//    printf("%d %d", cy, cx);

    fclose(stdin);
    fclose(stdout);

    return true;
}

int main(int argc, char *argv[])
{
    solve("", "");
    return 0;

    for (int i = 1; i < 71; i++) {
        char buf[100];
        sprintf(buf, "%03d.dat", i);
        fprintf(stderr, "%s\n", buf);
        FILE *fout = fopen(buf, "w");

        int n, m;

        n = rand() % (min(50, i)) + 1;
        m = rand() % (min(40, i)) + 1;
        m += 3 - m%3;


        vector<int> num;
        int cur = rand() % 10;
        for (int i = 0; i < n * m; i++)
            num.push_back(cur += rand() % 10 + 1);

        std::random_shuffle(num.begin(), num.end());
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                r[i][j] = num[i * m + j];

        int cx = rand() % m;
        int cy = rand() % n;
        int k = rand() % (i * 14) + 1;

        vector<int> ks;

        int height = n;
        int width = m;

        int dx[4] = {-1, 0, 1, 0};
        int dy[4] = {0, -1, 0, 1};
        for (int i = 0; i < k; i++) {
            while (1) {
                int d = rand() % 4;
                if (cy + dy[d] >= 0 && cy + dy[d] < height &&
                        cx + dx[d] >= 0 && cx + dx[d] < width) {

                    cy += dy[d];
                    cx += dx[d];
                    break;
                }
            }

            ks.push_back(r[cy][cx]);
        }

        if (r[cy][cx] == ks[0]) {
            i--;
            continue;
        }


        if (i > 20) {
            for (int i = 0; i < height; i++)
                for (int j = 0; j < width; j++)
                    if (rand() % 10 == 0)
                        for (int t = 0; t <= ks.size(); t++)
                            if (t == ks.size())
                                r[i][j] = r[cy][cx];
                            else if (r[i][j] == ks[t])
                                break;

        }

        fprintf(fout, "%d %d\n", n, m);
        for (int i = 0; i < height; i++) {
            for (int j = 0; j < width; j++)
                fprintf(fout, "%d ", r[i][j]);

            fprintf(fout, "\n");
        }

        fprintf(fout, "%d\n", k);
        for (int i = 0; i < k; i++)
            fprintf(fout, "%d ", ks[i]);

        fclose(fout);

        char buf2[10];
        sprintf(buf2, "%03d.ans", i);
        if (!solve(buf, buf2)) {
            i--;
            continue;
        }

    }
    return 0;
}
