#include <stdio.h>
#include <utility>
#include <stdlib.h>
#include <vector>

using std::swap;
using std::min;
using std::vector;

void solve(char *in, char *out) {
//    freopen(in, "r", stdin);
//    freopen(out, "w", stdout);

    int n, m;
    scanf("%d %d", &n, &m);
    vector<vector<int> > r;
    r.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        scanf("%d %d", &a, &b);
        r[a].push_back(b);
        r[b].push_back(a);
    }

    int k;
    scanf("%d", &k);
    vector<bool> raptors(n, false);
    for (int i = 0; i < k; i++) {
        int a;
        scanf("%d", &a);
        raptors[a] = true;
    }

    int u1 = 0;
    int u2 = 1;
    vector<int> x;
    x.push_back(0);
    vector<bool> was(n, false);
    vector<int> dist(n, 0);
    while (u1 < u2) {
        int v = x[u1++];
        for (int i = 0; i < r[v].size(); i++)
            if (!was[r[v][i]]) {
                was[r[v][i]] = true;
                dist[r[v][i]] = dist[v] + 1;
                x.push_back(r[v][i]);
                u2++;
            }
    }

    int mini = 100000;
    for (int i = 0; i < n; i++)
        if (raptors[i])
            mini = min(mini, dist[i]);

    printf("%d", (mini + 1) / 2);
    fclose(stdout);
}

int main(int argc, char *argv[])
{
    solve("", "");
    return 0;

    for (int i = 0; i < 100; i++) {
        char buf[100];
        sprintf(buf, "%03d.dat", i);
        fprintf(stderr, "%s\n", buf);
        FILE *fout = fopen(buf, "w");

        int n, m;



        if (i < 5) {
            n = rand() % 2 + 2;
        } else if (i < 60) {
            n = rand() % 1000;
        } else
            n = rand() % 10000 + 90000;


        m = rand() % (n * 4);

        fprintf(fout, "%d %d\n", n, m + n - 1);
        for (int j = 0; j < n - 1; j++)
            fprintf(fout, "%d %d\n", j, j + rand() % (n - j - 1) + 1);

        for (int j = 0; j < m; j++)
            fprintf(fout, "%d %d\n", rand() % n, rand() % n);

        int k = rand() % 10 + 1;
        fprintf(fout, "%d\n", k);
        for (int j = 0; j < k; j++)
            fprintf(fout, "%d ", rand()%(n-1)+1);

        fclose(fout);
        char buf2[10];
        sprintf(buf2, "%03d.ans", i);
        solve(buf, buf2);

    }
    return 0;
}
